
#include <windows.h>
#include "gfexit.h"


struct {
	HWND hwnd;
	WNDPROC wndproc;
} g_dll = {};


BOOL APIENTRY DllMain( 
	HMODULE hModule,
	DWORD fdwReason,
	LPVOID lpReserved)
{
	return TRUE;
}
const char* PluginName() { return "Graceful Exit"; }
const char* PluginCopyright() { return "n/a"; }



static LRESULT CALLBACK GfexitWndProcHook(
	HWND hwnd,
	UINT uMsg,
	WPARAM wParam,
	LPARAM lParam)
{
	if (uMsg == WM_QUERYENDSESSION)
	{
		return TRUE;
	}

	if (uMsg == WM_ENDSESSION)
	{
		if (wParam == TRUE)
		{
			SendMessage(g_dll.hwnd, WM_CLOSE, 0, 0);
		}

		return 0;
	}

	return CallWindowProc(
		g_dll.wndproc,
		g_dll.hwnd,
		uMsg,
		wParam,
		lParam);
}


void MaLaStart() 
{
	g_dll.hwnd = FindWindow(NULL, "MaLa");

	if (g_dll.hwnd == NULL)
		return;

	// Increase our reference count in order to prevent Mala from unloading us

	HMODULE hmodule = LoadLibraryA("plugins\\gfexit.mplugin");

	// hook the windowproc and redirect the 'shutdown' messages
	
	g_dll.wndproc = (WNDPROC)SetWindowLongPtrA(
		g_dll.hwnd,
		GWLP_WNDPROC,
		(LONG_PTR)GfexitWndProcHook);
}

